#include "ros/ros.h"
#include "std_msgs/String.h"
#include "std_msgs/Int8.h"
#include "std_msgs/Int16.h"
#include "std_msgs/Float32.h"
#include "std_msgs/Float64.h"
//#include "std_msgs/Uint8.h"
#include "ihm.h"

//INCLUDES DE TCPSOCK.C, UDPSOCK.C I SOCKBACE.C
#include "SockBase.h" 
#include "UDPSock.h"
#include <stdio.h>  
#include "SockBase.h"

//INCLUDE DE ERRNO
#include <errno.h>
#include <sstream>

		/** AQUEST PROGRAMA FARA DE PONT ENTRE ELS SENSORS I ACTUADORS,
		  * i ELS PROGRAMES PER CONTROLAR EL ROBOT
		  */


		//Declaracio de Variables globals

int errno;
int hola = 10;

char * addrRobot;
char * addrPIC;
char * addrPc;
char * addrIMU;

int PC_send_period=1000;			//Must be a multiple of 5ms
int rcv_count=0;			//Counter for number of paquets recieved from the dsPIC (5ms counter)
int send_PIC=0;				//Flag to start transmision to the dsPIC
int sendTimer=0;			//Flag per controlar que el thread de sendPIC no envii massa rapid
unsigned int real_time=0;		//Acumulated robot time
int nBytesInt = 0; 			//Variable per controlar els bytes a enviar cap al PIC

int PC_send_bytes=0;			//Number of bytes to be send to the PC
int Buf_PC_send_bytes[5];
int indexRebre = 0;
unsigned char bufModeCom[3];

//Definim configuraci� socket per PC
static int servSock=-1;                 /* Socket descriptor for server */
static int clntSock=-1;                 /* Socket descriptor for client */
static struct sockaddr_in echoServAddr; /* Local address */
static struct sockaddr_in echoClntAddr; /* Client address */
static unsigned int clntLen;            /* Length of client address data structure */
static unsigned short echoServPort=15000;     	//Server port
#define MAXPENDING 	5

int sockPIC;
int sockIMU;
int start_send=0;

// Threads
void * recvPIC(void *num);
void * recvPC(void *num);
void * sendPC(void *num);
void * sendPIC(void *num);
void * recvIMU(void *num);

void desglosa_PIC(void);
int composa_PC(int index);
void startSocketPIC(void);
void stopSocketPIC(void);
void startSocketIMU(void);
void gestio_int (int numero);
int calculaPaquet_PIC(void);
void calculaVarIMU(void);

//Variables utilitzades per convertir els valors dels bufUp's a un format que es pugui publicar
//Aixo es degut a que el ROS no es capas de publicar unsigned char*

  float Vtemsp = 0;
  float Vcodi_err = 0;

  int VVel_FL= 0;
  int VVel_FR= 0;
  int VVel_BL= 0;
  int VVel_BR= 0;
  int VInt_FL = 0;
  int VInt_FR = 0;
  int VInt_BL = 0;
  int VInt_BR = 0;

  char VBat = 0;

  char VVcc = 0;

  int Scont_FL= 0;
  int Scont_FR= 0;
  int Scont_BL= 0;
  int Scont_BR= 0;
  
  int VPos_X = 0;
  int VPos_Y = 0;
  int VTheta =0;
  
  double dVVel_FL= 0;
  double dVVel_FR= 0;
  double dVVel_BL= 0;
  double dVVel_BR= 0;
  double dVInt_FL = 0;
  double dVInt_FR = 0;
  double dVInt_BL = 0;
  double dVInt_BR = 0;

  double dVBat = 0;

  double dVVcc = 0;

  int dScont_FL= 0;
  int dScont_FR= 0;
  int dScont_BL= 0;
  int dScont_BR= 0;

  double dPos_X = 0;
  double dPos_Y = 0;
  double dTheta = 0;





int main(int argc, char **argv)
{

	

  /**
 The ros::init() function needs to see argc and argv so that it can perform
   * any ROS arguments and name remapping that were provided at the command line. For programmatic
   * remappings you can use a different version of init() which takes remappings
   * directly, but for most command-line programs, passing argc and argv is the easiest
   * way to do it.  The third argument to init() is the name of the node.
   *
   * You must call one of the versions of ros::init() before using any other
   * part of the ROS system.
   */
  ros::init(argc, argv, "Interlocutor");

  /**
   * NodeHandle is the main access point to communications with the ROS system.
   * The first NodeHandle constructed will fully initialize this node, and the last
   * NodeHandle destructed will close down the node.
   */
  ros::NodeHandle n;

 
 

	//DEFINIM ELS MISATGES QUE ES PUBLICARAN

  ros::Publisher chattor_pub = n.advertise<std_msgs::String>("chattor", 1000); 		//Es van utilitzar per fer proves
  //ros::Publisher chatter_pub = n.advertise<std_msgs::Int8>("hola",1000); 			//aquesta tambe
  ros::Publisher temps_pub = n.advertise<std_msgs::Int8>("Temps",1000);
  ros::Publisher codi_error_pub = n.advertise<std_msgs::Int8>("Error",1000);

	/**
	*Topics de Velocitats de les rodes FX significa roda davantera (front)
	*BX significa roda trasera (Back), i XL i XR signifiquen roda left i
	*right respectivament
	*/

  ros::Publisher Vel_FL_pub = n.advertise<std_msgs::Int8>("Velocitat_FL",1000);
  ros::Publisher Vel_FR_pub = n.advertise<std_msgs::Int8>("Velocitat_FR",1000);
  ros::Publisher Vel_BL_pub = n.advertise<std_msgs::Int8>("Velocitat_BL",1000);
  ros::Publisher Vel_BR_pub = n.advertise<std_msgs::Int8>("Velocitat_BR",1000);

	/**
	*Topics de Bateria I Vcc
	*/

  ros::Publisher Bat_pub = n.advertise<std_msgs::Float64>("Bateria",1000);
  ros::Publisher Vcc_pub = n.advertise<std_msgs::Float64>("Vcc",1000);

	/**
	*Topics de Intensitats de les rodes, les abreviacions funcionen igual
	*que les consignes de Velocitat
	*/

  ros::Publisher Int_FL_pub = n.advertise<std_msgs::Float64>("Intensitat_FL",1000);
  ros::Publisher Int_FR_pub = n.advertise<std_msgs::Float64>("Intensitat_FR",1000);
  ros::Publisher Int_BL_pub = n.advertise<std_msgs::Float64>("Intensitat_BL",1000);
  ros::Publisher Int_BR_pub = n.advertise<std_msgs::Float64>("Intensitat_BR",1000);

	/**
	*Topics de tensio de control
	*/

  ros::Publisher Cont_FL_pub = n.advertise<std_msgs::Int8>("Control_FL",1000);
  ros::Publisher Cont_FR_pub = n.advertise<std_msgs::Int8>("Control_FR",1000);
  ros::Publisher Cont_BL_pub = n.advertise<std_msgs::Int8>("Control_BL",1000);
  ros::Publisher Cont_BR_pub = n.advertise<std_msgs::Int8>("Control_BR",1000);

	/**
	*Topics de posicio
	*/

  ros::Publisher PosX_pub = n.advertise<std_msgs::Float32>("Pos_Y",1000);
  ros::Publisher PosY_pub = n.advertise<std_msgs::Float32>("Pos_X",1000);
  ros::Publisher Theta_pub = n.advertise<std_msgs::Float32>("Theta",1000);




 ros::Rate loop_rate(3);

  /**
   * Definicio de variables que agafaran valors 
   * Totes les variables portaran a davant una X davant per saber que son variables i no confondreles amb els std_msgs que aniran asociats
   */
  int hola = 10;
  int count=0;

 


  while (ros::ok())
  {



    /**
     * This are a message object. You stuff it with data, and then publish it.
     *
     *Definim els objectes misatge
     *
     */
    std_msgs::String msg;
    std_msgs::Float32 temps;
    std_msgs::Float32 codi_err;
    std_msgs::Int8 Vel_FL;
    std_msgs::Int8 Vel_FR;
    std_msgs::Int8 Vel_BL;
    std_msgs::Int8 Vel_BR;

    std_msgs::Float64 Int_FL;
    std_msgs::Float64 Int_FR;
    std_msgs::Float64 Int_BL;
    std_msgs::Float64 Int_BR;

    std_msgs::Float64 Bat;
    std_msgs::Float64 Vcc;  

    std_msgs::Int8 Cont_FL;
    std_msgs::Int8 Cont_FR;
    std_msgs::Int8 Cont_BL;
    std_msgs::Int8 Cont_BR;

    std_msgs::Float32 Pos_X;
    std_msgs::Float32 Pos_Y;
    std_msgs::Float32 Theta;


    /**
     * 			      			$$$$$   !!!!EL PROGRAMA ANIRA AQUI!!!   $$$$$$
     *
     */

	int resultatRecv=1;

	struct itimerval val;			// Variable per la configuraci� del timer
	struct sigaction interrupcio;		// Variable per la configuraci� d'interrupcions
	struct timeval timeoutSock;		//Variable per controlar el temps d'espera dels sockets.

	//0x88 = Possem a 1 el bit de més pes per indicar que es un paquet amb el Yaw,
	//i l'altre 1 indica que es correció d'angle
	PIC_sendBuf_minim[0] = 0x88;

	if ((1)){
		addrPIC = "192.168.1.18";
				
		printf("\nX\n");
		
		printf("IP PIC: %s\n",addrPIC);
		//iniciem el buffer down
		int k=0;
		int h=0;
		for (k=0; k<=39; k++){
			bufDown[k]=0;
		}
		for (h=0; h<=4; h++){
			for (k=0; k<=39; k++){
				bufUp[h][k]=0;
			}
		}
		
	}
	else{
		printf("\n**ERROR**\n\nComanda: ./comunicacio IP_dspic periode\n\n");
		exit(0);
	}


	startSocketPIC();
	if(sockPIC == -1){
		printf("\nError al crear el socket del PIC\n");
	}else{ //Netejem les possibles dades que hi puguin haver al dsPIC
		timeoutSock.tv_sec=0;
		timeoutSock.tv_usec=750000;

		setsockopt(sockPIC, SOL_SOCKET, SO_RCVTIMEO, &timeoutSock, sizeof(timeoutSock));

		printf("\nNetejant socket dsPIC...");
		while(recv(sockPIC, &bufUp[0][0], 1, 0)>=0){
			//printf("rebent %d\n", bufUp[0][0]);
		}
		//printf(" Ok !\n");

	}

	// CREACIO DELS THREADS
	if (pthread_create (&recvPICTh, NULL, recvPIC, (void *) 1) != 0){
		printf("\nError al crear el thread de recvPIC\n");
	}
	if (pthread_create (&sendPICTh, NULL, sendPIC, (void *) 1) != 0){
		printf("\nError al crear el thread de sendPIC\n");
	}
	
	

	pthread_mutex_init (&mutex_nBufEnviar, NULL);

	val.it_interval.tv_sec=0;
	val.it_interval.tv_usec=15000;
	val.it_value.tv_sec=0;
	val.it_value.tv_usec=15000;
	setitimer(ITIMER_REAL, &val, NULL);
	//printf ("period=%d\n",PC_send_period);

	//Interrupci� timer
	interrupcio.sa_handler = gestio_int;				// El manejador de de les senyals capturades es gestio_int
	sigemptyset (& (interrupcio . sa_mask));			// Especifiquem que no es bloquejar� cap senyal
	interrupcio.sa_flags = 0;					// Tots els flags desactivats
	sigaction(SIGALRM, &interrupcio, NULL);
	sigaction(SIGINT, &interrupcio, NULL);

	while(1){

	bufDown[0]= 0x00;
	bufDown[1]= 0xFF;
	bufDown[2]= 0x07;
	bufDown[3]= 0x03;
	bufDown[4]= 0x64;
	bufDown[5]= 0x64;
	bufDown[6]= 0x05;
	bufDown[7]= 0x7f;
	bufDown[8]= 0x00;
	bufDown[9]= 0x00;
	bufDown[10]= 0x00;
	bufDown[11]= 0x00;
	bufDown[12]= 0x00;
	bufDown[13]= 0x00;
	bufDown[14]= 0x00;
	bufDown[15]= 0x00;
	bufDown[16]= 0x00;
	bufDown[17]= 0x00;
	bufDown[18]= 0x00;
	bufDown[19]= 0x00;
	bufDown[20]= 0xFF;
	bufDown[21]= 0xFF;
	bufDown[22]= 0x00;
	bufDown[23]= 0x00;
	bufDown[24]= 0x00;
	bufDown[25]= 0x00;
	bufDown[26]= 0x00;
	bufDown[27]= 0x00;


	//Definicio del misatge exemple
    //msg2.data = hola ;


    std::stringstream ss;

    ss << "hello world " << count;
    msg.data = ss.str();
	


    ROS_INFO("%s", msg.data.c_str());
    chattor_pub.publish(msg);
	//Aqui s'acaba el misatge exemple

	//Assignem les variables als misatges
    
    temps.data= Vtemsp;
    codi_err.data = Vcodi_err;


	Bat.data=dVBat;
	Vcc.data=dVVcc;
	Vel_FL.data=VVel_FL;
	Vel_FL.data=VVel_FR;
	Vel_FL.data=VVel_BL;
	Vel_FL.data=VVel_BR;

	Int_FL.data=dVInt_FL;
	Int_FR.data=dVInt_FR;
	Int_BL.data=dVInt_BL;
	Int_BR.data=dVInt_BR;

	Cont_FL.data=Scont_FL;
	Cont_FR.data=Scont_FR;
	Cont_BL.data=Scont_BL;
	Cont_BR.data=Scont_BR;

	Pos_X.data=dPos_X;
	Pos_Y.data=dPos_Y;
	Theta.data=dTheta;



	//avisem al master que publicarem als topics
	send_PIC=1;
    ROS_INFO("%d", temps.data);
    ROS_INFO("%d", codi_err.data);
    ROS_INFO("%d", Vel_FL.data);
    ROS_INFO("%d", Vel_FR.data);
    ROS_INFO("%d", Vel_BL.data);
    ROS_INFO("%d", Vel_BR.data);
    ROS_INFO("%f", Int_FL.data);
    ROS_INFO("%f", Int_FR.data);
    ROS_INFO("%f", Int_BL.data);
    ROS_INFO("%f", Int_BR.data);
    ROS_INFO("%f", Bat.data);
    ROS_INFO("%f", Vcc.data);
    ROS_INFO("%f", Cont_FL.data);
    ROS_INFO("%f", Cont_FR.data);
    ROS_INFO("%f", Cont_BL.data);
    ROS_INFO("%f", Cont_BR.data);
    ROS_INFO("%f", Pos_X.data);
    ROS_INFO("%f", Pos_Y.data);
    ROS_INFO("%f", Theta.data);


	//Publiquem els misatges


    temps_pub.publish(temps); 
    codi_error_pub.publish(codi_err); 
    Vel_FL_pub.publish(Vel_FL); 
    Vel_FR_pub.publish(Vel_FR); 
    Vel_BL_pub.publish(Vel_BL); 
    Vel_BR_pub.publish(Vel_BR); 
    Int_FL_pub.publish(Int_FL); 
    Int_FR_pub.publish(Int_FR); 
    Int_BL_pub.publish(Int_BL); 
    Int_BR_pub.publish(Int_BR); 
    Bat_pub.publish(Bat); 
    Vcc_pub.publish(Vcc); 
    Cont_FL_pub.publish(Cont_FL); 
    Cont_FR_pub.publish(Cont_FR); 
    Cont_BL_pub.publish(Cont_BL); 
    Cont_BR_pub.publish(Cont_BR);
    PosX_pub.publish(Pos_X); 
    PosY_pub.publish(Pos_Y); 
    Theta_pub.publish(Theta);



    /**
     * The publish() function is how you send messages. The parametr
     * is the message object. The type of this object must agree with the type
     * given as a template parameter to the advertise<>() call, as was done
     * in the constructor above.
     */

   // chatter_pub.publish(msg2);
 

    ros::spinOnce();

    loop_rate.sleep();
    ++count;
  }

  return 0;
			
	}


}




// THREAD REBRE DEL dsPIC
void * recvPIC (void * num){
	//Definim la variable que anira movent el punter en les diferents posicions de bufUp[index][]
	int index=0;

	unsigned short aux1;
	unsigned short aux2;
	unsigned short aux3;
	unsigned short aux4;

	while(1){
		//Obtenim la part del paquet que es fixe!
		recv(sockPIC, &bufUp[index][0], 5, MSG_WAITALL);
//printf("ADEUPERE%x, %x, %x, %x\n",bufUp[index][0],bufUp[index][1],bufUp[index][2],bufUp[index][3]);
		//Obtenim pas per pas la part variable
		if(fVelocitat)
{	         (sockPIC, &bufUp[index][5], 4, MSG_WAITALL);
	aux1 = bufUp[index][5];
	aux2 = bufUp[index][6];
	aux3 = bufUp[index][7];
	aux4 = bufUp[index][8];

	VVel_FL= (int)aux1;
	VVel_FR= (int)aux2;
	VVel_BL= (int)aux3;
	VVel_BR= (int)aux4;
	
	//printf("\n\nVelocitats: %d, %d, %d, %d\n",VVel_FL,VVel_FR,VVel_BL,VVel_BR);
	//printf("ADEU2%d, %x, %s, %s\n",velocitatFL,velocitatFR,velocitatRL,velocitatRR);

}
		if(fBattery) 	
{
	recv(sockPIC, &bufUp[index][9], 2, MSG_WAITALL);
	aux1 = bufUp[index][9];
	aux2 = bufUp[index][10];

if(aux1!=0)
	{dVBat=(double)aux1/10;}
if(aux2!=0)
	{dVVcc=((double)aux2/100)+3.5;}
	//printf("Bat: %f, %f,\n",dVBat,dVVcc); 
	//printf("Bat: %i, %i,\n",bufUp[index][9],bufUp[index][10]); 
}
		if(fPosition) 	
{	recv(sockPIC, &bufUp[index][11], 5, MSG_WAITALL);


	aux1 = bufUp[index][13];
	aux1 = aux1 < 8;
	aux2 = bufUp[index][11];
	VPos_X = aux1|aux2;
	dPos_X= (double)VPos_X/100;

	aux1 = bufUp[index][14];
	aux1 = aux1 < 8;
	aux2 = bufUp[index][12];
	VPos_Y = aux1|aux2;
	dPos_Y= (double)VPos_Y/100;

	aux1 = bufUp[index][15];
	dTheta = (aux1*360)/255;

	//printf("Pos: %f, %f, %d, %d,%d\n",bufUp[index][11],bufUp[index][12],bufUp[index][13],bufUp[index][14],bufUp[index][15]);
}
		if(fCurrent) 	
{	recv(sockPIC, &bufUp[index][16], 8, MSG_WAITALL);

	aux1 = l_Int_FL;
	aux1 = aux1 < 8;
	aux2 = h_Int_FL;
	VInt_FL = aux1|aux2;
	dVInt_FL = (double)VInt_FL/100;

	aux1 = l_Int_FR;
	aux1 = aux1 < 8;
	aux2 = h_Int_FR;
	VInt_FR = aux1|aux2;
	dVInt_FR = (double)VInt_FR/100;

	aux1 = l_Int_RL;
	aux1 = aux1 < 8;
	aux2 = h_Int_RL;
	VInt_BL = aux1|aux2;
	dVInt_BL = (double)VInt_BL/100;

	aux1 = l_Int_RR;
	aux1 = aux1 < 8;
	aux2 = h_Int_RR;
	VInt_BR = aux1|aux2;
	dVInt_BR = (double)VInt_BR/100;

	//printf("Corrents: %f, %f, %i, %f,\n",VInt_FL, VInt_FR, VInt_BL, VInt_BR);
}
		if(fCtlSig) 	
{	recv(sockPIC, &bufUp[index][24], 4, MSG_WAITALL);

	aux1 = bufUp[index][24];
	aux2 = bufUp[index][25];
	aux3 = bufUp[index][26];
	aux4 = bufUp[index][27];

	Scont_FL= aux1;
	Scont_FR= aux2;
	Scont_BL= aux3;
	Scont_BR= aux4;

	//printf("Senyals de Control: %d, %d, %d, %d\n",Scont_FL, Scont_FR, Scont_BL, Scont_BR);
}
		if(fDiffTick) 	recv(sockPIC, &bufUp[index][28], 2, MSG_WAITALL);
		if(fSensors)	recv(sockPIC, &bufUp[index][30], 4, MSG_WAITALL);
		if(fEncoders) 	
{
	recv(sockPIC, &bufUp[index][34], 4, MSG_WAITALL);
	
	/*aux1 = bufUp[index][24];
	aux2 = bufUp[index][25];
	aux3 = bufUp[index][26];
	aux4 = bufUp[index][27];

	Scont_FL= aux1;
	Scont_FR= aux2;
	Scont_BL= aux3;
	Scont_BR= aux4;*/
	//printf("Encoders: %x, %x, %x, %x\n",bufUp[index][24], bufUp[index][25], h_encoder_R, l_encoder_R);

}		

		//printf("HOLA!:)\n%d\n",Flags_PICtoPC);
		//printf("HOLA2!:)\n%d\n",peticioFlags);
		rcv_count++;

			index++;
			if(index>4) index = 0;
			//Preparem la variable indexRebre, que apunta a la penultima posició més actual
			indexRebre = index-1;
			rcv_count = 0;
		

	}
}

void * sendPIC (void * num){
	//while(!start_send);
	while(1){sendTimer = 1;
		if(sendTimer == 1){
			if (send_PIC==1){
				
				if (yaw_to_PIC){
					Flags_PCtoPIC = Flags_PCtoPIC|0x08;
					h_corr_t = h_yaw;
					l_corr_t = l_yaw;
				}
				
				//Enviem al PIC la part fixa del paquet
				send(sockPIC, &bufDown[0], 8, 0);
				//Enviem psd per pas la part variable
				if (fPosOrder)	send(sockPIC, &bufDown[8],4,0);
				if (fTOrder)	send(sockPIC, &bufDown[12],1,0);
				if (fCorrPos)	send(sockPIC, &bufDown[13],4,0);
				if (fCorrT)	send(sockPIC, &bufDown[17],2,0);
				if (fErrAd)	send(sockPIC, &bufDown[19],1,0);
				if (fConfPID)	send(sockPIC, &bufDown[20],6,0);
				//printf("Jo estic enviant!\n%d\n",fPosOrder);
				send_PIC=0;
			}
			else if(yaw_to_PIC == 1){
				//Enviem la capçalera del paquet "mini"
				send(sockPIC, &PIC_sendBuf_minim[0], 1, 0);
				h_corr_t = h_yaw;
				l_corr_t = l_yaw;
				send(sockPIC, &bufDown[17], 2, 0);
			}
			sendTimer = 0;
		}
	}

}



void startSocketPIC(){
	sockPIC = CreateTCPClient(addrPIC,10001);
printf("\n entra al startsocketPIC %d %s", sockPIC, addrPIC );
}

void stopSocketPIC(){
	CloseSock(sockPIC);
}

// Gesti� de les senyals capturades
void gestio_int (int numero)
{
	int resultatRecv = 0;
	int i;
	char final1=0, final2=0, final3=0;

	switch (numero) 
	{
	case SIGALRM :
		//Flag que controla quan enviar al PIC per conservar l'ample de banda
		sendTimer = 1;

		break;

	case SIGINT:
		/**********************************************
		Codi executat per la interrupció de Ctrl+C. A part, està configurat per que quan Labview es desconecti
		salti aquesta interrupció.

		Aquesta part ens assegura que la transmissió de l'IMU es "tanca" correctament i que no queda res
		al buffer.
		***********************************************/
		printf("\nS'ha pulsat Ctrl+C!\n");
		

		printf("\nFinalitzant comunicacio amb el PIC...");
		
		CloseSock(sockPIC);

		printf("\nSortint ...\n\n");
		exit(1);
		break;
	}
}



		//FUNCIONS DE TCPSOCK



int CreateTCPServer(int Port)
{

	int s;

	s = CreateSock(SOCK_STREAM);

	if ( s == -1 )
		return -1;

	if (BindSock(s,Port) == -1 )
		return -1;

	if (listen(s, SOMAXCONN) < 0)
		return -1;

	return s;
}




int AcceptConn(int Sock,char * RemoteAddr)
{
	struct sockaddr_in addr;
	int addrSize = sizeof(struct sockaddr_in);
	int s;

	s = accept(Sock,(struct sockaddr *)&addr,(socklen_t *)&addrSize);

	strcpy(RemoteAddr,inet_ntoa(addr.sin_addr));

	return s;
}

int CreateTCPClient2(struct sockaddr_in dest_addr)
{
	int s;
	//struct sockaddr_in dest_addr;

	s = CreateSock(SOCK_STREAM);

	if ( s == -1 )
		return -1;

	dest_addr.sin_family = AF_INET;
	//dest_addr.sin_port = htons(Port);
	//HostNameToAddr(HostName,&dest_addr);

    if ( connect(s, (struct sockaddr *)&dest_addr, sizeof(struct sockaddr)) == -1 )
    	return -1;

    return s;
}

int CreateTCPClient(char * HostName,int Port)
{
	printf("\n entra al create tcpclient");int s;
	struct sockaddr_in dest_addr;

	s = CreateSock(SOCK_STREAM);

	if ( s == -1 )
		return -1;

	dest_addr.sin_family = AF_INET;
	dest_addr.sin_port = htons(Port);
	HostNameToAddr(HostName,&dest_addr);

   if ( connect(s, (struct sockaddr *)&dest_addr, sizeof(struct sockaddr)) == -1 )
{ printf("\n PETA AQUI MERDA! %d \n", errno);
    	return -1;
}
    return s;
}

int TCPSend(int Sock,char * Data,int Len)
{
	return send(Sock, Data, Len, 0);
}

int TCPRecv(int Sock,char * Buf,int Len)
{

	return recv(Sock, Buf, Len, 0);
}

		//FUNCIONS DE UDPSOCK


int CreateUDPServer(int Port)
{
	int s;

	s = CreateSock(SOCK_DGRAM);

	if ( s == -1 )
		return -1;

	if (BindSock(s,Port) == -1 )
		return -1;


	return s;
}





int CreateUDPClient(char * HostName,int Port,int Type,struct sockaddr_in * Serv)
{
	int s;

	printf("%s %d %d\n",HostName,Port,Type);
	s = CreateSock(SOCK_DGRAM);

	if ( s == -1 )
	{   printf("CreateSock \n");
			return -1;
	}

	Serv->sin_family = AF_INET;
	Serv->sin_port = htons(Port);

	if (Type == 0)
	{
		if ( HostNameToAddr(HostName,Serv) == -1)
			return -1;
	}
	else /* HostName = IP address */
	{
		if ( inet_aton(HostName,&Serv->sin_addr) == 0)
					return -1;
	}

	return s;
}


int UDPRecv(int Sock,char * Buf,int Len)
{

	struct sockaddr_in client;
	int client_addr_len;

	client_addr_len=sizeof(client);

	return recvfrom(Sock,Buf,Len,0,(struct sockaddr *)&client,(socklen_t*)&client_addr_len);

}

int UDPSend(int Sock,char * Buf, int Len,struct sockaddr_in * Dest)
{

	return sendto(Sock,Buf,Len,0,(struct sockaddr *)Dest,sizeof(struct sockaddr_in));
}



		//FUNCIONS DE SOCKBASE




int CreateSock(int SockType)
{
printf("\n entra al createsock" );
	return socket(AF_INET,SockType,0);

}

int BindSock(int Sock,int Port)
{
	struct sockaddr_in serv;

  	serv.sin_family=AF_INET;
  	serv.sin_addr.s_addr=htonl(INADDR_ANY);
  	serv.sin_port=htons(Port);

    return bind(Sock,(struct sockaddr *)&serv,sizeof(serv)) ;

}


int HostNameToAddr(char * HostName,struct sockaddr_in * Addr)
{
	struct hostent *hp;

  	hp=gethostbyname(HostName);
  	if(hp==(struct hostent *)0)
  		return -1;

  	memcpy((char *) &Addr->sin_addr,(char *)hp->h_addr,hp->h_length);


  	return 0;
}



void CloseSock(int Sock)
{
	if ( close(Sock) == -1 )
		perror("CloseSock");
}
