#include "ros/ros.h"
#include "std_msgs/String.h"
#include "std_msgs/Int8.h"
#include "std_msgs/Int16.h"
#include "std_msgs/Float64.h"
#include "std_msgs/Float32.h"

	/**
	 *  !CALLBACKS!
	 */
void tempsCallback(const std_msgs::Int8::ConstPtr& msg2)
{
  
  ROS_INFO("temps: [%d]", msg2->data);
}

void ErrorCallback(const std_msgs::Int8::ConstPtr& msg2)
{
  
  ROS_INFO("Error: [%d]", msg2->data);
}
	//Velocitats

void Vel_FLCallback(const std_msgs::Int8::ConstPtr& msg2)
{
  
  ROS_INFO("Velocitat Roda davant-esquerra: [%d]", msg2->data);
}
void Vel_FRCallback(const std_msgs::Int8::ConstPtr& msg2)
{
  
  ROS_INFO("Velocitat Roda davant-dreta: [%d]", msg2->data);
}

void Vel_BLCallback(const std_msgs::Int8::ConstPtr& msg2)
{
  
  ROS_INFO("Velocitat Roda darrera-esquerra: [%d]", msg2->data);
}

void Vel_BRCallback(const std_msgs::Int8::ConstPtr& msg2)
{
  
  ROS_INFO("Velocitat Roda darrera-dreta: [%d]", msg2->data);
}
	//Senyals de control

void Cont_FLCallback(const std_msgs::Int8::ConstPtr& msg2)
{
  
  ROS_INFO("Control Roda davant-esquerra: [%d]", msg2->data);
}
void Cont_FRCallback(const std_msgs::Int8::ConstPtr& msg2)
{
  
  ROS_INFO("Control Roda davant-dreta: [%d]", msg2->data);
}

void Cont_BLCallback(const std_msgs::Int8::ConstPtr& msg2)
{
  
  ROS_INFO("Control Roda darrera-esquerra: [%d]", msg2->data);
}

void Cont_BRCallback(const std_msgs::Int8::ConstPtr& msg2)
{
  
  ROS_INFO("Control Roda darrera-dreta: [%d]", msg2->data);
}
	//Intensitats
void Int_FLCallback(const std_msgs::Float64::ConstPtr& msg2)
{
  
  ROS_INFO("Intensitat Roda davant-esquerra: [%f]", msg2->data);
}

void Int_FRCallback(const std_msgs::Float64::ConstPtr& msg2)
{
  
  ROS_INFO("Intensitat Roda davant-dreta: [%f]", msg2->data);
}

void Int_BLCallback(const std_msgs::Float64::ConstPtr& msg2)
{
  
  ROS_INFO("Intensitat Roda darrera-esquerra: [%f]", msg2->data);
}

void Int_BRCallback(const std_msgs::Float64::ConstPtr& msg2)
{
  
  ROS_INFO("Intensitat Roda darrera-esquerra: [%f]", msg2->data);
}

	//Bateria

void BatCallback(const std_msgs::Float64::ConstPtr& msg2)
{
  
  ROS_INFO("Bateria: [%f]V", msg2->data);
}

void VccCallback(const std_msgs::Float64::ConstPtr& msg2)
{
  
  ROS_INFO("Vcc: [%f]V", msg2->data);
}

	//Posicio

void PosXCallback(const std_msgs::Float32::ConstPtr& msg2)
{
  
  ROS_INFO("PosX: [%f]m", msg2->data);
}

void PosYCallback(const std_msgs::Float32::ConstPtr& msg2)
{
  
  ROS_INFO("PosY: [%f]m", msg2->data);
}
void ThetaCallback(const std_msgs::Float32::ConstPtr& msg2)
{
  
  ROS_INFO("Theta: [%f]º", msg2->data);
}


int main(int argc, char **argv)
{

  /**
   * The ros::init() function needs to see argc and argv so that it can perform
   * any ROS arguments and name remapping that were provided at the command line. For programmatic
   * remappings you can use a different version of init() which takes remappings
   * directly, but for most command-line programs, passing argc and argv is the easiest
   * way to do it.  The third argument to init() is the name of the node.
   *
   * You must call one of the versions of ros::init() before using any other
   * part of the ROS system.
   */
  ros::init(argc, argv, "listener");

  /**
   * NodeHandle is the main access point to communications with the ROS system.
   * The first NodeHandle constructed will fully initialize this node, and the last
   * NodeHandle destructed will close down the node.
   */
  ros::NodeHandle n;

  /**
   * The subscribe() call is how you tell ROS that you want to receive messages
   * on a given topic.  This invokes a call to the ROS
   * master node, which keeps a registry of who is publishing and who
   * is subscribing.  Messages are passed to a callback function, here
   * called chatterCallback.  subscribe() returns a Subscriber object that you
   * must hold on to until you want to unsubscribe.  When all copies of the Subscriber
   * object go out of scope, this callback will automatically be unsubscribed from
   * this topic.
   *
   * The second parameter to the subscribe() function is the size of the message
   * queue.  If messages are arriving faster than they are being processed, this
   * is the number of messages that will be buffered up before beginning to throw
   * away the oldest ones.
   */
  //ros::Subscriber sub1 = n.subscribe("chattor", 1000, chattorCallback);
  ros::Subscriber sub2 = n.subscribe("Temps", 1000, tempsCallback);
  ros::Subscriber sub3 = n.subscribe("Error", 1000, ErrorCallback);
  ros::Subscriber sub4 = n.subscribe("Velocitat_FL", 1000, Vel_FLCallback);
  ros::Subscriber sub5 = n.subscribe("Velocitat_FR", 1000, Vel_FRCallback);
  ros::Subscriber sub6 = n.subscribe("Velocitat_BL", 1000, Vel_BLCallback);
  ros::Subscriber sub7 = n.subscribe("Velocitat_BR", 1000, Vel_BRCallback);
  ros::Subscriber sub8 = n.subscribe("Intensitat_FL", 1000, Int_FLCallback);
  ros::Subscriber sub9 = n.subscribe("Intensitat_FR", 1000, Int_FRCallback);
  ros::Subscriber sub10 = n.subscribe("Intensitat_BL", 1000, Int_BLCallback);
  ros::Subscriber sub11 = n.subscribe("Intensitat_BR", 1000, Int_BRCallback);
  ros::Subscriber sub12 = n.subscribe("Bateria", 1000, BatCallback);
  ros::Subscriber sub13 = n.subscribe("Vcc", 1000, VccCallback);
  ros::Subscriber sub14 = n.subscribe("Control_FL", 1000, Cont_FLCallback);
  ros::Subscriber sub15 = n.subscribe("Control_FR", 1000, Cont_FRCallback);
  ros::Subscriber sub16 = n.subscribe("Control_BL", 1000, Cont_BLCallback);
  ros::Subscriber sub17 = n.subscribe("Control_BR", 1000, Cont_BRCallback);
  ros::Subscriber sub18 = n.subscribe("Pos_X", 1000, PosXCallback);
  ros::Subscriber sub19 = n.subscribe("Pos_Y", 1000, PosYCallback);
  ros::Subscriber sub20 = n.subscribe("Theta", 1000, ThetaCallback);
  


  /**
   * ros::spin() will enter a loop, pumping callbacks.  With this version, all
   * callbacks will be called from within this thread (the main one).  ros::spin()
   * will exit when Ctrl-C is pressed, or the node is shutdown by the master.
   */
  ros::spin();

  return 0;
}
